Xerces-J API: Class CoreDocumentImpl

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.xerces.dom
Class CoreDocumentImpl

    java.lang.Object
      |
      +--org.apache.xerces.dom.NodeImpl
            |
            +--org.apache.xerces.dom.ChildNode
                  |
                  +--org.apache.xerces.dom.ParentNode
                        |
                        +--org.apache.xerces.dom.CoreDocumentImpl

Direct Known Subclasses:
  DocumentImpl

public class CoreDocumentImpl
extends ParentNode
implements Document

The Document interface represents the entire HTML or XML document. Conceptually, it is the root of the document tree, and provides the primary access to the document's data.

Since elements, text nodes, comments, processing instructions, etc. cannot exist outside the context of a Document, the Document interface also contains the factory methods needed to create these objects. The Node objects created have a ownerDocument attribute which associates them with the Document within whose context they were created.

The CoreDocumentImpl class only implements the DOM Core. Additional modules are supported by the more complete DocumentImpl subclass.

Note: When any node in the document is serialized, the entire document is serialized along with it.

Since:
  PR-DOM-Level-1-19980818.
Version:
Author:
  Arnaud Le Hors, IBM, Joe Kesselman, IBM, Andy Clark, IBM, Ralf Pfeiffer, IBM
See Also:
  Serialized Form

Field Summary
`protected boolean` | `allowGrammarAccess` Allow grammar access.
`protected int` | `changes` Number of alterations made to this document since its creation.
`protected ElementImpl` | `docElement` Document element.
`protected DocumentTypeImpl` | `docType` Document type.
`protected java.lang.String` | `encoding` Experimental DOM Level 3 feature: Document encoding
`protected boolean` | `errorChecking` Bypass error checking.
`protected java.util.Hashtable` | `identifiers` Identifiers.
`protected static int[]` | `kidOK` Table for quick check of child insertion.
`protected boolean` | `standalone` Experimental DOM Level 3 feature: Document standalone
`protected java.lang.String` | `version` Experimental DOM Level 3 feature: Document version

Fields inherited from class org.apache.xerces.dom.ParentNode
`fCachedChild, fCachedChildIndex, fCachedLength, firstChild, ownerDocument`

Fields inherited from class org.apache.xerces.dom.ChildNode
`nextSibling, previousSibling`

Fields inherited from class org.apache.xerces.dom.NodeImpl
`ELEMENT_DEFINITION_NODE, FIRSTCHILD, flags, HASSTRING, IGNORABLEWS, OWNED, ownerNode, READONLY, SPECIFIED, SYNCCHILDREN, SYNCDATA, UNNORMALIZED`

Fields inherited from interface org.w3c.dom.Node
`ATTRIBUTE_NODE, CDATA_SECTION_NODE, COMMENT_NODE, DOCUMENT_FRAGMENT_NODE, DOCUMENT_NODE, DOCUMENT_TYPE_NODE, ELEMENT_NODE, ENTITY_NODE, ENTITY_REFERENCE_NODE, NOTATION_NODE, PROCESSING_INSTRUCTION_NODE, TEXT_NODE`

Constructor Summary
`CoreDocumentImpl()` NON-DOM: Actually creating a Document is outside the DOM's spec, since it has to operate in terms of a particular implementation.
`CoreDocumentImpl(boolean grammarAccess)` Constructor.
`CoreDocumentImpl(DocumentType doctype)` For DOM2 support.
`CoreDocumentImpl(DocumentType doctype, boolean grammarAccess)` For DOM2 support.

Method Summary
`protected void` | `addEventListener(NodeImpl node, java.lang.String type, EventListener listener, boolean useCapture)`
`Node` | `adoptNode(Node source)` DOM Level 3 WD - Experimental Change the node's ownerDocument, and its subtree, to this Document
`protected void` | `changed()` Denotes that this node has changed.
`protected int` | `changes()` Returns the number of changes to this node.
`java.lang.Object` | `clone()` Clone.
`Node` | `cloneNode(boolean deep)` Deep-clone a document, including fixing ownerDoc for the cloned children.
`protected void` | `cloneNode(CoreDocumentImpl newdoc, boolean deep)` internal method to share code with subclass
`Attr` | `createAttribute(java.lang.String name)` Factory method; creates an Attribute having this Document as its OwnerDoc.
`Attr` | `createAttributeNS(java.lang.String namespaceURI, java.lang.String qualifiedName)` Introduced in DOM Level 2.
`CDATASection` | `createCDATASection(java.lang.String data)` Factory method; creates a CDATASection having this Document as its OwnerDoc.
`Comment` | `createComment(java.lang.String data)` Factory method; creates a Comment having this Document as its OwnerDoc.
`DocumentFragment` | `createDocumentFragment()` Factory method; creates a DocumentFragment having this Document as its OwnerDoc.
`DocumentType` | `createDocumentType(java.lang.String qualifiedName, java.lang.String publicID, java.lang.String systemID)` NON-DOM Factory method; creates a DocumentType having this Document as its OwnerDoc.
`Element` | `createElement(java.lang.String tagName)` Factory method; creates an Element having this Document as its OwnerDoc.
`ElementDefinitionImpl` | `createElementDefinition(java.lang.String name)` NON-DOM Factory method: creates an element definition.
`Element` | `createElementNS(java.lang.String namespaceURI, java.lang.String qualifiedName)` Introduced in DOM Level 2.
`Entity` | `createEntity(java.lang.String name)` NON-DOM Factory method; creates an Entity having this Document as its OwnerDoc.
`EntityReference` | `createEntityReference(java.lang.String name)` Factory method; creates an EntityReference having this Document as its OwnerDoc.
`Notation` | `createNotation(java.lang.String name)` NON-DOM Factory method; creates a Notation having this Document as its OwnerDoc.
`ProcessingInstruction` | `createProcessingInstruction(java.lang.String target, java.lang.String data)` Factory method; creates a ProcessingInstruction having this Document as its OwnerDoc.
`Text` | `createTextNode(java.lang.String data)` Factory method; creates a Text node having this Document as its OwnerDoc.
`protected boolean` | `dispatchEvent(NodeImpl node, Event event)`
`DocumentType` | `getDoctype()` For XML, this provides access to the Document Type Definition.
`Element` | `getDocumentElement()` Convenience method, allowing direct access to the child node which is considered the root of the actual document content.
`Element` | `getElementById(java.lang.String elementId)` Introduced in DOM Level 2 Returns the Element whose ID is given by elementId.
`NodeList` | `getElementsByTagName(java.lang.String tagname)` Return a live collection of all descendent Elements (not just immediate children) having the specified tag name.
`NodeList` | `getElementsByTagNameNS(java.lang.String namespaceURI, java.lang.String localName)` Introduced in DOM Level 2.
`java.lang.String` | `getEncoding()` DOM Level 3 WD - Experimental.
`boolean` | `getErrorChecking()` Returns true if the DOM implementation performs error checking.
`Element` | `getIdentifier(java.lang.String idName)` Returns a previously registered element with the specified identifier name, or null if no element is registered.
`java.util.Enumeration` | `getIdentifiers()` Returns an enumeration registered of identifier names.
`DOMImplementation` | `getImplementation()` Retrieve information describing the abilities of this particular DOM implementation.
`java.lang.String` | `getNodeName()` Returns the node name.
`short` | `getNodeType()` Returns the node type.
`Document` | `getOwnerDocument()` The `Document` object associated with this node.
`boolean` | `getStandalone()` DOM Level 3 WD - Experimental.
`boolean` | `getStrictErrorChecking()` EXPERIMENTAL! Based on the Document Object Model (DOM) Level 3 Core Working Draft of 5 June 2001..
`protected java.lang.Object` | `getUserData(NodeImpl n)` Retreive user data related to a given node
`java.lang.String` | `getVersion()` DOM Level 3 WD - Experimental.
`Node` | `importNode(Node source, boolean deep)` Copies a node from another document to this document.
`Node` | `insertBefore(Node newChild, Node refChild)` Since a Document may contain at most one top-level Element child, and at most one DocumentType declaraction, we need to subclass our add-children methods to implement this constraint.
`protected boolean` | `isKidOK(Node parent, Node child)` Uses the kidOK lookup table to check whether the proposed tree structure is legal.
`static boolean` | `isXMLName(java.lang.String s)` Check the string against XML's definition of acceptable names for elements and attributes and so on using the XMLCharacterProperties utility class
`void` | `putIdentifier(java.lang.String idName, Element element)` Registers an identifier name with a specified element node.
`Node` | `removeChild(Node oldChild)` Since insertBefore caches the docElement (and, currently, docType), removeChild has to know how to undo the cache REVISIT: According to the spec it is not allowed to alter neither the document element nor the document type in any way
`protected void` | `removeEventListener(NodeImpl node, java.lang.String type, EventListener listener, boolean useCapture)`
`void` | `removeIdentifier(java.lang.String idName)` Removes a previously registered element with the specified identifier name.
`Node` | `replaceChild(Node newChild, Node oldChild)` Since we cache the docElement (and, currently, docType), replaceChild has to update the cache REVISIT: According to the spec it is not allowed to alter neither the document element nor the document type in any way
`void` | `setEncoding(java.lang.String value)` DOM Level 3 WD - Experimental.
`void` | `setErrorChecking(boolean check)` Sets whether the DOM implementation performs error checking upon operations.
`void` | `setStandalone(boolean value)` DOM Level 3 WD - Experimental.
`void` | `setStrictErrorChecking(boolean check)` EXPERIMENTAL! Based on the Document Object Model (DOM) Level 3 Core Working Draft of 5 June 2001..
`protected void` | `setUserData(NodeImpl n, java.lang.Object data)` Store user data related to a given node This is a place where we could use weak references! Indeed, the node here won't be GC'ed as long as some user data is attached to it, since the userData table will have a reference to the node.
`void` | `setVersion(java.lang.String value)` DOM Level 3 WD - Experimental.

Methods inherited from class org.apache.xerces.dom.ParentNode
`getChildNodes, getChildNodesUnoptimized, getFirstChild, getLastChild, getLength, hasChildNodes, item, normalize, setReadOnly, synchronizeChildren`

Methods inherited from class org.apache.xerces.dom.ChildNode
`getNextSibling, getParentNode, getPreviousSibling`

Methods inherited from class org.apache.xerces.dom.NodeImpl
`addEventListener, appendChild, dispatchEvent, getAttributes, getLocalName, getNamespaceURI, getNodeValue, getPrefix, getReadOnly, getUserData, hasAttributes, isSupported, removeEventListener, setNodeValue, setPrefix, setUserData, synchronizeData, toString`

Methods inherited from class java.lang.Object
`equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Field Detail

### docType

    protected DocumentTypeImpl docType

  Document type.

### docElement

    protected ElementImpl docElement

  Document element.

### encoding

    protected java.lang.String encoding

  Experimental DOM Level 3 feature: Document encoding

### version

    protected java.lang.String version

  Experimental DOM Level 3 feature: Document version

### standalone

    protected boolean standalone

  Experimental DOM Level 3 feature: Document standalone

### identifiers

    protected java.util.Hashtable identifiers

  Identifiers.

### kidOK

    protected static int[] kidOK

  Table for quick check of child insertion.

### changes

    protected int changes

  Number of alterations made to this document since its creation. Serves as a "dirty bit" so that live objects such as NodeList can recognize when an alteration has been made and discard its cached state information.

  Any method that alters the tree structure MUST cause or be accompanied by a call to changed(), to inform it that any outstanding NodeLists may have to be updated.

  (Required because NodeList is simultaneously "live" and integer- indexed -- a bad decision in the DOM's design.)

  Note that changes which do not affect the tree's structure -- changing the node's name, for example -- do _not_ have to call changed().

  Alternative implementation would be to use a cryptographic Digest value rather than a count. This would have the advantage that "harmless" changes (those producing equal() trees) would not force NodeList to resynchronize. Disadvantage is that it's slightly more prone to "false negatives", though that's the difference between "wildly unlikely" and "absurdly unlikely". IF we start maintaining digests, we should consider taking advantage of them. Note: This used to be done a node basis, so that we knew what subtree changed. But since only DeepNodeList really use this today, the gain appears to be really small compared to the cost of having an int on every (parent) node plus having to walk up the tree all the way to the root to mark the branch as changed everytime a node is changed. So we now have a single counter global to the document. It means that some objects may flush their cache more often than necessary, but this makes nodes smaller and only the document needs to be marked as changed.

### allowGrammarAccess

    protected boolean allowGrammarAccess

  Allow grammar access.

### errorChecking

    protected boolean errorChecking

  Bypass error checking.

Constructor Detail

### CoreDocumentImpl

    public CoreDocumentImpl()

  NON-DOM: Actually creating a Document is outside the DOM's spec, since it has to operate in terms of a particular implementation.

### CoreDocumentImpl

    public CoreDocumentImpl(boolean grammarAccess)

  Constructor.

### CoreDocumentImpl

    public CoreDocumentImpl(DocumentType doctype)

  For DOM2 support. The createDocument factory method is in DOMImplementation.

### CoreDocumentImpl

    public CoreDocumentImpl(DocumentType doctype,
                            boolean grammarAccess)

  For DOM2 support.

Method Detail

### getOwnerDocument

    public final Document getOwnerDocument()

  Description copied from interface: Node
  The `Document` object associated with this node. This is also the `Document` object used to create new nodes. When this node is a `Document` or a `DocumentType` which is not used with any `Document` yet, this is `null`.
  Overrides:
    getOwnerDocument in class ParentNode

### getNodeType

    public short getNodeType()

  Returns the node type.
  Overrides:
    getNodeType in class NodeImpl

### getNodeName

    public java.lang.String getNodeName()

  Returns the node name.
  Overrides:
    getNodeName in class NodeImpl

### cloneNode

    public Node cloneNode(boolean deep)

  Deep-clone a document, including fixing ownerDoc for the cloned children. Note that this requires bypassing the WRONG_DOCUMENT_ERR protection. I've chosen to implement it by calling importNode which is DOM Level 2.
  Overrides:
    cloneNode in class ParentNode
  Parameters:
    `deep` - boolean, iff true replicate children
  Returns:
    org.w3c.dom.Node

### cloneNode

    protected void cloneNode(CoreDocumentImpl newdoc,
                             boolean deep)

  internal method to share code with subclass

### insertBefore

    public Node insertBefore(Node newChild,
                             Node refChild)
                      throws DOMException

  Since a Document may contain at most one top-level Element child, and at most one DocumentType declaraction, we need to subclass our add-children methods to implement this constraint. Since appendChild() is implemented as insertBefore(,null), altering the latter fixes both.

  While I'm doing so, I've taken advantage of the opportunity to cache documentElement and docType so we don't have to search for them. REVISIT: According to the spec it is not allowed to alter neither the document element nor the document type in any way

  Overrides:
    insertBefore in class ParentNode
  Tags copied from interface: Node
  Parameters:
    `newChildThe` - node to insert.
    `refChildThe` - reference node, i.e., the node before which the new node must be inserted.
  Returns:
    The node being inserted.
  Throws:
    DOMException - HIERARCHY_REQUEST_ERR: Raised if this node is of a type that does not allow children of the type of the `newChild` node, or if the node to insert is one of this node's ancestors.
    WRONG_DOCUMENT_ERR: Raised if `newChild` was created from a different document than the one that created this node.
    NO_MODIFICATION_ALLOWED_ERR: Raised if this node is readonly or if the parent of the node being inserted is readonly.
    NOT_FOUND_ERR: Raised if `refChild` is not a child of this node.

### removeChild

    public Node removeChild(Node oldChild)
                     throws DOMException

  Since insertBefore caches the docElement (and, currently, docType), removeChild has to know how to undo the cache REVISIT: According to the spec it is not allowed to alter neither the document element nor the document type in any way
  Overrides:
    removeChild in class ParentNode
  Tags copied from interface: Node
  Parameters:
    `oldChildThe` - node being removed.
  Returns:
    The node removed.
  Throws:
    DOMException - NO_MODIFICATION_ALLOWED_ERR: Raised if this node is readonly.
    NOT_FOUND_ERR: Raised if `oldChild` is not a child of this node.

### replaceChild

    public Node replaceChild(Node newChild,
                             Node oldChild)
                      throws DOMException

  Since we cache the docElement (and, currently, docType), replaceChild has to update the cache REVISIT: According to the spec it is not allowed to alter neither the document element nor the document type in any way
  Overrides:
    replaceChild in class ParentNode
  Tags copied from interface: Node
  Parameters:
    `newChildThe` - new node to put in the child list.
    `oldChildThe` - node being replaced in the list.
  Returns:
    The node replaced.
  Throws:
    DOMException - HIERARCHY_REQUEST_ERR: Raised if this node is of a type that does not allow children of the type of the `newChild` node, or if the node to put in is one of this node's ancestors.
    WRONG_DOCUMENT_ERR: Raised if `newChild` was created from a different document than the one that created this node.
    NO_MODIFICATION_ALLOWED_ERR: Raised if this node or the parent of the new node is readonly.
    NOT_FOUND_ERR: Raised if `oldChild` is not a child of this node.

### createAttribute

    public Attr createAttribute(java.lang.String name)
                         throws DOMException

  Factory method; creates an Attribute having this Document as its OwnerDoc.
  Specified by:
    createAttribute in interface Document
  Parameters:
    `name` - The name of the attribute. Note that the attribute's value is _not_ established at the factory; remember to set it!
  Throws:
    DOMException(INVALID_NAME_ERR) - if the attribute name is not acceptable.

### createCDATASection

    public CDATASection createCDATASection(java.lang.String data)
                                    throws DOMException

  Factory method; creates a CDATASection having this Document as its OwnerDoc.
  Specified by:
    createCDATASection in interface Document
  Parameters:
    `data` - The initial contents of the CDATA
  Throws:
    DOMException(NOT_SUPPORTED_ERR) - for HTML documents. (HTML not yet implemented.)

### createComment

    public Comment createComment(java.lang.String data)

  Factory method; creates a Comment having this Document as its OwnerDoc.
  Specified by:
    createComment in interface Document
  Parameters:
    `data` - The initial contents of the Comment.

### createDocumentFragment

    public DocumentFragment createDocumentFragment()

  Factory method; creates a DocumentFragment having this Document as its OwnerDoc.
  Specified by:
    createDocumentFragment in interface Document
  Tags copied from interface: Document
  Returns:
    A new `DocumentFragment`.

### createElement

    public Element createElement(java.lang.String tagName)
                          throws DOMException

  Factory method; creates an Element having this Document as its OwnerDoc.
  Specified by:
    createElement in interface Document
  Parameters:
    `tagName` - The name of the element type to instantiate. For XML, this is case-sensitive. For HTML, the tagName parameter may be provided in any case, but it must be mapped to the canonical uppercase form by the DOM implementation.
  Throws:
    DOMException(INVALID_NAME_ERR) - if the tag name is not acceptable.

### createEntityReference

    public EntityReference createEntityReference(java.lang.String name)
                                          throws DOMException

  Factory method; creates an EntityReference having this Document as its OwnerDoc.
  Specified by:
    createEntityReference in interface Document
  Parameters:
    `name` - The name of the Entity we wish to refer to
  Throws:
    DOMException(NOT_SUPPORTED_ERR) - for HTML documents, where nonstandard entities are not permitted. (HTML not yet implemented.)

### createProcessingInstruction

    public ProcessingInstruction createProcessingInstruction(java.lang.String target,
                                                             java.lang.String data)
                                                      throws DOMException

  Factory method; creates a ProcessingInstruction having this Document as its OwnerDoc.
  Specified by:
    createProcessingInstruction in interface Document
  Parameters:
    `target` - The target "processor channel"
    `data` - Parameter string to be passed to the target.
  Throws:
    DOMException(INVALID_NAME_ERR) - if the target name is not acceptable.
    DOMException(NOT_SUPPORTED_ERR) - for HTML documents. (HTML not yet implemented.)

### createTextNode

    public Text createTextNode(java.lang.String data)

  Factory method; creates a Text node having this Document as its OwnerDoc.
  Specified by:
    createTextNode in interface Document
  Parameters:
    `data` - The initial contents of the Text.

### getDoctype

    public DocumentType getDoctype()

  For XML, this provides access to the Document Type Definition. For HTML documents, and XML documents which don't specify a DTD, it will be null.
  Specified by:
    getDoctype in interface Document

### getEncoding

    public java.lang.String getEncoding()

  DOM Level 3 WD - Experimental. The encoding of this document (part of XML Declaration)
  Specified by:
    getEncoding in interface Document

### getVersion

    public java.lang.String getVersion()

  DOM Level 3 WD - Experimental. The version of this document (part of XML Declaration)
  Specified by:
    getVersion in interface Document

### getStandalone

    public boolean getStandalone()

  DOM Level 3 WD - Experimental. standalone that specifies whether this document is standalone (part of XML Declaration)
  Specified by:
    getStandalone in interface Document

### getDocumentElement

    public Element getDocumentElement()

  Convenience method, allowing direct access to the child node which is considered the root of the actual document content. For HTML, where it is legal to have more than one Element at the top level of the document, we pick the one with the tagName "HTML". For XML there should be only one top-level (HTML not yet supported.)
  Specified by:
    getDocumentElement in interface Document

### getElementsByTagName

    public NodeList getElementsByTagName(java.lang.String tagname)

  Return a live collection of all descendent Elements (not just immediate children) having the specified tag name.
  Specified by:
    getElementsByTagName in interface Document
  Parameters:
    `tagname` - The type of Element we want to gather. "*" will be taken as a wildcard, meaning "all elements in the document."
  See Also:
    `DeepNodeListImpl`

### getImplementation

    public DOMImplementation getImplementation()

  Retrieve information describing the abilities of this particular DOM implementation. Intended to support applications that may be using DOMs retrieved from several different sources, potentially with different underlying representations.
  Specified by:
    getImplementation in interface Document

### setErrorChecking

    public void setErrorChecking(boolean check)

  Sets whether the DOM implementation performs error checking upon operations. Turning off error checking only affects the following DOM checks:
  - Checking strings to make sure that all characters are legal XML characters
  - Hierarchy checking such as allowed children, checks for cycles, etc.

  Turning off error checking does not turn off the following checks:

  - Read only checks
  - Checks related to DOM events

### setStrictErrorChecking

    public void setStrictErrorChecking(boolean check)

  Description copied from interface: Document

  EXPERIMENTAL! Based on the Document Object Model (DOM) Level 3 Core Working Draft of 5 June 2001..

  An attribute specifying whether errors checking is enforced or not. When set to `false`, the implementation is free to not test every possible error case normally defined on DOM operations, and not raise any `DOMException`. In case of error, the behavior is undefined. This attribute is `true` by defaults.

  Specified by:
    setStrictErrorChecking in interface Document

### setEncoding

    public void setEncoding(java.lang.String value)

  DOM Level 3 WD - Experimental. An attribute specifying, as part of the XML declaration, the encoding of this document. This is null when unspecified.
  Specified by:
    setEncoding in interface Document

### setVersion

    public void setVersion(java.lang.String value)

  DOM Level 3 WD - Experimental. version - An attribute specifying, as part of the XML declaration, the version number of this document. This is null when unspecified
  Specified by:
    setVersion in interface Document

### setStandalone

    public void setStandalone(boolean value)

  DOM Level 3 WD - Experimental. standalone - An attribute specifying, as part of the XML declaration, whether this document is standalone
  Specified by:
    setStandalone in interface Document

### getErrorChecking

    public boolean getErrorChecking()

  Returns true if the DOM implementation performs error checking.

### getStrictErrorChecking

    public boolean getStrictErrorChecking()

  Description copied from interface: Document

  EXPERIMENTAL! Based on the Document Object Model (DOM) Level 3 Core Working Draft of 5 June 2001..

  An attribute specifying whether errors checking is enforced or not. When set to `false`, the implementation is free to not test every possible error case normally defined on DOM operations, and not raise any `DOMException`. In case of error, the behavior is undefined. This attribute is `true` by defaults.

  Specified by:
    getStrictErrorChecking in interface Document

### createDocumentType

    public DocumentType createDocumentType(java.lang.String qualifiedName,
                                           java.lang.String publicID,
                                           java.lang.String systemID)
                                    throws DOMException

  NON-DOM Factory method; creates a DocumentType having this Document as its OwnerDoc. (REC-DOM-Level-1-19981001 left the process of building DTD information unspecified.)
  Parameters:
    `name` - The name of the Entity we wish to provide a value for.
  Throws:
    DOMException(NOT_SUPPORTED_ERR) - for HTML documents, where DTDs are not permitted. (HTML not yet implemented.)

### createEntity

    public Entity createEntity(java.lang.String name)
                        throws DOMException

  NON-DOM Factory method; creates an Entity having this Document as its OwnerDoc. (REC-DOM-Level-1-19981001 left the process of building DTD information unspecified.)
  Parameters:
    `name` - The name of the Entity we wish to provide a value for.
  Throws:
    DOMException(NOT_SUPPORTED_ERR) - for HTML documents, where nonstandard entities are not permitted. (HTML not yet implemented.)

### createNotation

    public Notation createNotation(java.lang.String name)
                            throws DOMException

  NON-DOM Factory method; creates a Notation having this Document as its OwnerDoc. (REC-DOM-Level-1-19981001 left the process of building DTD information unspecified.)
  Parameters:
    `name` - The name of the Notation we wish to describe
  Throws:
    DOMException(NOT_SUPPORTED_ERR) - for HTML documents, where notations are not permitted. (HTML not yet implemented.)

### createElementDefinition

    public ElementDefinitionImpl createElementDefinition(java.lang.String name)
                                                  throws DOMException

  NON-DOM Factory method: creates an element definition. Element definitions hold default attribute values.

### importNode

    public Node importNode(Node source,
                           boolean deep)
                    throws DOMException

  Copies a node from another document to this document. The new nodes are created using this document's factory methods and are populated with the data from the source's accessor methods defined by the DOM interfaces. Its behavior is otherwise similar to that of cloneNode.

  According to the DOM specifications, document nodes cannot be imported and a NOT_SUPPORTED_ERR exception is thrown if attempted.

  Specified by:
    importNode in interface Document
  Tags copied from interface: Document
  Parameters:
    `importedNodeThe` - node to import.
    `deepIf` - `true`, recursively import the subtree under the specified node; if `false`, import only the node itself, as explained above. This has no effect on `Attr` , `EntityReference`, and `Notation` nodes.
  Returns:
    The imported node that belongs to this `Document`.
  Throws:
    DOMException - NOT_SUPPORTED_ERR: Raised if the type of node being imported is not supported.

### adoptNode

    public Node adoptNode(Node source)

  DOM Level 3 WD - Experimental Change the node's ownerDocument, and its subtree, to this Document
  Specified by:
    adoptNode in interface Document
  Parameters:
    `source` - The node to adopt.
  See Also:
    `DocumentImpl.importNode`

### getElementById

    public Element getElementById(java.lang.String elementId)

  Introduced in DOM Level 2 Returns the Element whose ID is given by elementId. If no such element exists, returns null. Behavior is not defined if more than one element has this ID.

  Note: The DOM implementation must have information that says which attributes are of type ID. Attributes with the name "ID" are not of type ID unless so defined. Implementations that do not know whether attributes are of type ID or not are expected to return null.

  Specified by:
    getElementById in interface Document
  See Also:
    `getIdentifier(java.lang.String)`

### putIdentifier

    public void putIdentifier(java.lang.String idName,
                              Element element)

  Registers an identifier name with a specified element node. If the identifier is already registered, the new element node replaces the previous node. If the specified element node is null, removeIdentifier() is called.
  See Also:
    `getIdentifier(java.lang.String)`, `removeIdentifier(java.lang.String)`

### getIdentifier

    public Element getIdentifier(java.lang.String idName)

  Returns a previously registered element with the specified identifier name, or null if no element is registered.
  See Also:
    `putIdentifier(java.lang.String, org.w3c.dom.Element)`, `removeIdentifier(java.lang.String)`

### removeIdentifier

    public void removeIdentifier(java.lang.String idName)

  Removes a previously registered element with the specified identifier name.
  See Also:
    `putIdentifier(java.lang.String, org.w3c.dom.Element)`, `getIdentifier(java.lang.String)`

### getIdentifiers

    public java.util.Enumeration getIdentifiers()

  Returns an enumeration registered of identifier names.

### createElementNS

    public Element createElementNS(java.lang.String namespaceURI,
                                   java.lang.String qualifiedName)
                            throws DOMException

  Introduced in DOM Level 2.

  Creates an element of the given qualified name and namespace URI. If the given namespaceURI is null or an empty string and the qualifiedName has a prefix that is "xml", the created element is bound to the predefined namespace "http://www.w3.org/XML/1998/namespace" [Namespaces].

  Specified by:
    createElementNS in interface Document
  Parameters:
    `namespaceURI` - The namespace URI of the element to create.
    `qualifiedName` - The qualified name of the element type to instantiate.
  Returns:
    Element A new Element object with the following attributes:
  Throws:
    DOMException - INVALID_CHARACTER_ERR: Raised if the specified name contains an invalid character.
    DOMException - NAMESPACE_ERR: Raised if the qualifiedName has a prefix that is "xml" and the namespaceURI is neither null nor an empty string nor "http://www.w3.org/XML/1998/namespace", or if the qualifiedName has a prefix different from "xml" and the namespaceURI is null or an empty string.
  Since:
    WD-DOM-Level-2-19990923

### createAttributeNS

    public Attr createAttributeNS(java.lang.String namespaceURI,
                                  java.lang.String qualifiedName)
                           throws DOMException

  Introduced in DOM Level 2.

  Creates an attribute of the given qualified name and namespace URI. If the given namespaceURI is null or an empty string and the qualifiedName has a prefix that is "xml", the created element is bound to the predefined namespace "http://www.w3.org/XML/1998/namespace" [Namespaces].

  Specified by:
    createAttributeNS in interface Document
  Parameters:
    `namespaceURI` - The namespace URI of the attribute to create. When it is null or an empty string, this method behaves like createAttribute.
    `qualifiedName` - The qualified name of the attribute to instantiate.
  Returns:
    Attr A new Attr object.
  Throws:
    DOMException - INVALID_CHARACTER_ERR: Raised if the specified name contains an invalid character.
  Since:
    WD-DOM-Level-2-19990923

### getElementsByTagNameNS

    public NodeList getElementsByTagNameNS(java.lang.String namespaceURI,
                                           java.lang.String localName)

  Introduced in DOM Level 2.

  Returns a NodeList of all the Elements with a given local name and namespace URI in the order in which they would be encountered in a preorder traversal of the Document tree.

  Specified by:
    getElementsByTagNameNS in interface Document
  Parameters:
    `namespaceURI` - The namespace URI of the elements to match on. The special value "*" matches all namespaces. When it is null or an empty string, this method behaves like getElementsByTagName.
    `localName` - The local name of the elements to match on. The special value "*" matches all local names.
  Returns:
    NodeList A new NodeList object containing all the matched Elements.
  Since:
    WD-DOM-Level-2-19990923

### clone

    public java.lang.Object clone()
                           throws java.lang.CloneNotSupportedException

  Clone.
  Overrides:
    clone in class java.lang.Object

### isXMLName

    public static boolean isXMLName(java.lang.String s)

  Check the string against XML's definition of acceptable names for elements and attributes and so on using the XMLCharacterProperties utility class

### isKidOK

    protected boolean isKidOK(Node parent,
                              Node child)

  Uses the kidOK lookup table to check whether the proposed tree structure is legal.

### changed

    protected void changed()

  Denotes that this node has changed.
  Overrides:
    changed in class NodeImpl

### changes

    protected int changes()

  Returns the number of changes to this node.
  Overrides:
    changes in class NodeImpl

### setUserData

    protected void setUserData(NodeImpl n,
                               java.lang.Object data)

  Store user data related to a given node This is a place where we could use weak references! Indeed, the node here won't be GC'ed as long as some user data is attached to it, since the userData table will have a reference to the node.

### getUserData

    protected java.lang.Object getUserData(NodeImpl n)

  Retreive user data related to a given node

### addEventListener

    protected void addEventListener(NodeImpl node,
                                    java.lang.String type,
                                    EventListener listener,
                                    boolean useCapture)

### removeEventListener

    protected void removeEventListener(NodeImpl node,
                                       java.lang.String type,
                                       EventListener listener,
                                       boolean useCapture)

### dispatchEvent

    protected boolean dispatchEvent(NodeImpl node,
                                    Event event)

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 1999-2001 Apache XML Project. All Rights Reserved.